<?php
/* 
Plugin Name: Genki Youtube Comments
Plugin URI: http://ericulous.com/2007/05/16/wp-plugin-genki-youtube-comments/
Version: 1.4
Plugin URI: http://ericulous.com/
Description: Insert YouTube comments into your post's comment
Author: Genkisan
Author URI: http://ericulous.com
*/
error_reporting(0);

add_action ('admin_menu', 'genki_youtube_comments_menu');
add_action('genki_youtube_cron', 'insert_youtube_comments');
add_filter('cron_schedules', 'add_sched_options');

function genki_youtube_comments_menu() {
	add_option('genki_youtube_schedule', 'never');
    if (function_exists('add_options_page')) {
		add_options_page('YouTube Comments', 'YouTube Comments', 8, basename(__FILE__), 'genki_youtube_comments_manage');
	}
}

function genki_youtube_comments_manage() {
if (isset($_POST['update_message'])) {

	?><div id="message" class="updated fade"><p><strong><?php

	update_option('genki_youtube_schedule', $_POST['schedule']);
	
	if ($_POST['schedule'] == 'never') {
		wp_clear_scheduled_hook('genki_youtube_cron');
	}
	if ($_POST['schedule'] == 'hourly') {
		wp_clear_scheduled_hook('genki_youtube_cron');
		wp_schedule_event(time() + 60, 'hourly', 'genki_youtube_cron');
	}
	if ($_POST['schedule'] == 'daily') {
		wp_clear_scheduled_hook('genki_youtube_cron');
		wp_schedule_event(time() + 60, 'daily', 'genki_youtube_cron');
	}
	if ($_POST['schedule'] == 'weekly') {
		wp_clear_scheduled_hook('genki_youtube_cron');
		wp_schedule_event(time() + 60, 'weekly', 'genki_youtube_cron');
	}

	echo "Options Updated!";

	?></strong></p></div><?php
}

//$dev_id = get_option('genki_youtube_dev_id');
$schedule = get_option('genki_youtube_schedule');
?>
	<div class=wrap>
	<h2>Genki Youtube Comments</h2>
		<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
			
            <fieldset class="options">
				<legend><strong>Schedule</strong>
				<p>
					<input type="radio" id="schedule" name="schedule" value="never" <?php if ($schedule == 'never') echo 'checked' ; ?> /> Never<br />
					<input type="radio" id="schedule" name="schedule" value="hourly" <?php if ($schedule == 'hourly') echo 'checked' ; ?> /> Once Hourly<br />
					<input type="radio" id="schedule" name="schedule" value="daily" <?php if ($schedule == 'daily') echo 'checked' ; ?> /> Once Daily<br />
					<input type="radio" id="schedule" name="schedule" value="weekly" <?php if ($schedule == 'weekly') echo 'checked' ; ?> /> Once Weekly
				</p>
                <p class="submit">
                    <input type="submit" name="update_message" class="button-primary" value="Save Changes" />
                </p>
                </legend>
			</fieldset>
		</form>
             
        <hr style='border:none;border-top:1px dashed #c6c6c6;height:0;' />
        
		<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
			<fieldset class="options">
			<legend><strong>Manual Update</strong></legend>
            <?php
			if (!function_exists('curl_version') && !ini_get('allow_url_fopen')) {
				echo '<strong>Error!</strong><br />';
				if (function_exists('curl_version')) {
					echo '*Curl is disabled<br />';
				}
				if (ini_get('allow_url_fopen') ) {
					echo '*Allow_url_fopen php directive is disabled<br />';
				}
				echo 'The Youtube Comments plugin requires either Curl or allow_url_fopen to be anabled.<br />Please check with you host on enabling either one of them.';
			}
			?>
			<p class="submit">
				<input type="submit" name="manual_update" class="button-primary" value="Update Comments Now" />
            </p>
            </fieldset>
		</form>
        
       	<?php 
		if (isset($_POST['manual_update'])) {
			insert_youtube_comments();
        }
		?>
        
        <hr style='border:none;border-top:1px dashed #c6c6c6;height:0;' />
        
        <fieldset class="options">
			<legend><strong>Usage</strong>
				<p>
                    1. Find the post which you want the comments to be inserted.<br />
                    2. Go to the Custom Fields section and add "youtubevidid" as key.<br />
                    3. For value, add your YouTube video id e.g X2BEhk1fqZ<br />
                    4. If more than 1 vid, simply add more keys: youtubevidid1, youtubevidid2 and so on<br />
                    5. Click "Update Comments Now" above<br /><br />
                    <img style="border:1px solid #ddd;padding-bottom:5px;" src="<?php echo plugins_url() ?>/genki-youtube-comments/screenshot-2.gif" />
				</p>
			</legend>
		</fieldset>
        
	</div>
<?php
}

function add_sched_options($sched) {
	$sched['weekly'] = array('interval' => 604800, 'display' => __('Once Weekly'));
	return $sched;
}

function insert_youtube_comments() {
	global $wpdb;
	require_once('class_xml.php');
	
	$videoposts = $wpdb->get_results("SELECT post_id, meta_value FROM " . $wpdb->prefix . "postmeta WHERE meta_key LIKE 'youtubevidid%'");	

	if ($videoposts) {	
		foreach ($videoposts as $videopost) {

			$x = new xml();
		
			if (function_exists('curl_version')) {
				// cURL modification by Piotr GRD
				$url = "http://gdata.youtube.com/feeds/api/videos/$videopost->meta_value/comments";
				$user_agent = "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)";
				$ytc = curl_init();
				curl_setopt($ytc, CURLOPT_URL, $url);
				curl_setopt($ytc, CURLOPT_FAILONERROR, 1);
				curl_setopt($ytc, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt($ytc, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ytc, CURLOPT_PORT, 80);
				curl_setopt($ytc, CURLOPT_TIMEOUT, 15);
				curl_setopt($ytc, CURLOPT_USERAGENT, $user_agent);
				$source = curl_exec($ytc);
				curl_close($ytc);
				// end of cURL modification by Piotr GRD
			} else {
				$source = file_get_contents("http://gdata.youtube.com/feeds/api/videos/$videopost->meta_value/comments");
			}
			
			//if (!$x->fetch($source)) {
			
			  //echo "<h2>There was a problem parsing your XML!</h2>";
			  //echo $x->log;
			  //exit();
			//}
			
			if ($x->fetch($source) && $x->data->FEED[0]->ENTRY[0]->ID[0]->_text != NULL) {
				foreach ($x->data->FEED[0]->ENTRY as $ytvideo) {
			
				$comment_post_ID = $videopost->post_id;
				$comment_author = $ytvideo->AUTHOR[0]->NAME[0]->_text;
				$comment_author_email = 'api@youtube.com';
				$comment_author_url = 'http://www.youtube.com/profile?user=' . $ytvideo->AUTHOR[0]->NAME[0]->_text;
				$comment_author_IP = preg_replace( '/[^0-9., ]/', '',$_SERVER['REMOTE_ADDR'] );
				$comment_date = genki_parse_w3cdtf($ytvideo->PUBLISHED[0]->_text);
				$comment_content = ' [..YouTube..] ' . addslashes(urldecode(str_replace('%EF%BB%BF', '', urlencode($ytvideo->CONTENT[0]->_text))));
				$comment_approved = 1;
				$comment_agent = 'Youtube API';
				$comment_type = '';
				$comment_parent = 0;
				$user_id = 0;
				  
				$recordexist = $wpdb->query("SELECT comment_ID FROM " . $wpdb->prefix . "comments WHERE comment_author = '$comment_author' AND comment_content = '$comment_content'");

				if (!$recordexist) {
					$result = $wpdb->query("INSERT INTO $wpdb->comments
					(comment_post_ID, comment_author, comment_author_email, comment_author_url, comment_author_IP, comment_date, comment_date_gmt, comment_content, comment_approved, comment_agent, comment_type, comment_parent, user_id)
					VALUES
					('$comment_post_ID', '$comment_author', '$comment_author_email', '$comment_author_url', '$comment_author_IP', FROM_UNIXTIME($comment_date), FROM_UNIXTIME($comment_date), '$comment_content', '$comment_approved', '$comment_agent', '$comment_type', '$comment_parent', '$user_id')
					");

					wp_update_comment_count($videopost->post_id);
					
					echo '<strong>Post:</strong> ';
					echo '<a href="' . get_permalink($comment_post_ID) . '">' . get_the_title($comment_post_ID) .'</a>';
					echo '<br /><strong>Author:</strong> ';
					echo $ytvideo->AUTHOR[0]->NAME[0]->_text;
					echo '<br /><strong>Comment:</strong> ';
					echo $ytvideo->CONTENT[0]->_text;
					echo '<br /><br />';
					echo 'New Comment inserted.<hr style="border:none;border-top:1px dashed #c6c6c6;height:0;" />';
				}
				
				} //foreach ($x->data->FEED[0]->ENTRY as $ytvideo) {
			}		
		} //foreach ($videoposts as $videopost) {
	} //if (!videoposts)
} //function insert_youtube_comments()

//borrow from rss.php
function genki_parse_w3cdtf ( $date_str ) {

	# regex to match wc3dtf
	$pat = "/(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2})(:(\d{2}))?(?:([-+])(\d{2}):?(\d{2})|(Z))?/";

	if ( preg_match( $pat, $date_str, $match ) ) {
		list( $year, $month, $day, $hours, $minutes, $seconds) =
			array( $match[1], $match[2], $match[3], $match[4], $match[5], $match[7]);

		# calc epoch for current date assuming GMT
		$epoch = gmmktime( $hours, $minutes, $seconds, $month, $day, $year);

		$offset = 0;
		if ( $match[11] == 'Z' ) {
			# zulu time, aka GMT
		}
		else {
			list( $tz_mod, $tz_hour, $tz_min ) =
				array( $match[8], $match[9], $match[10]);

			# zero out the variables
			if ( ! $tz_hour ) { $tz_hour = 0; }
			if ( ! $tz_min ) { $tz_min = 0; }

			$offset_secs = (($tz_hour*60)+$tz_min)*60;

			# is timezone ahead of GMT?  then subtract offset
			#
			if ( $tz_mod == '+' ) {
				$offset_secs = $offset_secs * -1;
			}

			$offset = $offset_secs;
		}
		$epoch = $epoch + $offset;
		return $epoch;
	}
	else {
		return -1;
	}
}
?>